<%--
 * Component: iface
 *
 * WEB interface for importing orders from external systems (RIS).
 *
 *
 * $Author$
 * $Date$
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State             : $State$
 *
 * Supported fields
 *
 * PatientID               PAID
 * PatientName             PNAM
 * BirthDateTime           PDOB
 * Sex                     PSEX
 * Address                 PADD
 * PhoneNumbers            PAPH
 * Height                  -
 * Weight                  -
 * 
 * ReferringPhysician      PHRF
 * RefPhysAddress          RPAD
 * RefPhysPhone            RPPH
 * CurrentPatientLocation  PLOC
 * PatientHistory          PHIS
 * 
 * 
 * StudyInstanceUID        SYUI
 * ControlID               -
 * AccessionNumber         ACCN
 * PlacerOrderNumber       -
 * FillerOrderNumber       -
 * Modality                MODA
 * StationAE               PSAE
 * StartDateTime           SCHD
 * EndDateTime             SCSD
 * Priority                PRST
 * Status                  STAT
 * Description             DSCR
 * ProcedureID             PRID
 * Reason                  REAS
 * RequestingPhysician     RQPH
 * PerformingPhysician     PHPR
 * 
 * CPT4Code                CPT4
 * CPT4Description         -
 * ICD9Code                ICD9
 * ICD9Description         -
 * OtherCode1              -
 * OtherScheme1            -
 * OtherDescription1       -
 * OtherCode2              -
 * OtherScheme2            -
 * OtherDescription2       -
 * 
 * // should be kept undocumented
 * Study Date              SYDT
 * 
 * Regular parameters:
 *
 * cControl = new | update | cancel | complete
 *
 * cDevice : One of the server's devices. It will be considered as the origin of the importOrder.jsp calling (default: HTTPIFACE)
 * 
 * cBack : redirect instead of writing to standard output
 * 
--%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.util.*, imagemed.imtables.*, imagemed.exception.*,
			imagemed.imsession.*,imagemed.jsputil.*,java.util.*,imagemed.dcprocessing.OrderImport"

%><%-- Input Parameters --%><%
	IMSession is = new IMSession(request, response, out); 

	String parBack      = request.getParameter("cBack");

	Syslog slog = new Syslog("importOrder.jsp", 0 , IMEnvBase.getEnv("LOG_OPER_FACILITY"));

%><%!
  
	static String fields[] = {
		"PAID", // PatientID
		"PANM", // PatientName
		"PDOB", // BirthDateTime
		"PSEX", // Sex
		"PADD", // Address
		"PAPH", // PhoneNumbers
		"PHRF", // ReferringPhysician
		"RPAD", // RefPhysAddress
		"RPPH", // RefPhysPhone
		"PLOC", // CurrentPatientLocation
		"PHIS", // PatientHistory
		"SYUI", // StudyInstanceUID
		"ACCN", // AccessionNumber
		"MODA", // Modality
		"PSAE", // StationAE
		"SCHD", // StartDateTime
		"SCSD", // EndDateTime
		"PRST", // Priority
		"STAT", // Status
		"DSCR", // Description
		"PRID", // ProcedureID
		"SPSI", // Scheduled Procedure Step ID
		"REAS", // Reason
		"RQPH", // RequestingPhysician
		"PHPR", // PerformingPhysician
		"BDYP", // BodyPart
		"INSN", // Institution Name
		"UDF1", // User defined field 1 (128 char)
		"UDF2", // User defined field 2 (32 char)
		"UDF3", // User defined field 3 (32 char)
		"UDF4", // User defined field 4 (32 char)
		"UDF5", // User defined field 5 (32 char)
		"UDF6", // User defined field 6 (64 char)
		"UDF7", // User defined field 7 (16 char)
		"UDF8", // User defined field 8 (16 char)
		"UDF9", // User defined field 9 (16 char)
		"UDF0", // User defined field 0 (16 char)
		"CPT4", // CPT4Code
		"ICD9", // ICD9Code
		"SYDT"  // Study Date - images scanned later
	};

%><%

	String errorMsg = null;

	try {

		// Check login
		if ( !IfaceToolbox.isRegOK( is ) ) {
			OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "import" );
			logEntry.setField( OperLogEntry.FIELD.HOST, request.getRemoteAddr() );
			logEntry.setField( OperLogEntry.FIELD.MESSAGE, "no rights" );
			logEntry.log( slog, Syslog.LOG_ERR );

			//			slog.syslog(Syslog.LOG_ERR,
			//					"ERROR STUDY import - - - - - " + request.getRemoteAddr() + " - - - - - - no_rights");
			throw new IMException( "Import Disabled." );
		}

		boolean hasSchedulingRight = false;
		if ( is.regRights != null ) {
			hasSchedulingRight = ( -1 != is.regRights.indexOf( 'H' ) );
		}

		// Check if the user has rights to create orders
		if ( !hasSchedulingRight ) {
			OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "import" );
			logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
			logEntry.setField( OperLogEntry.FIELD.MESSAGE, "no rights" );
			logEntry.log( slog, Syslog.LOG_ERR );

			//			slog.syslog(Syslog.LOG_ERR,
			//					"ERROR STUDY import " + is.regID + " - - - - - - - - - - - no_rights");
			throw new IMException( is.regID + " has no right to create orders." );
		}

		String SQLtables[] = { "Dcstudy", "Dcobject", "" };
		IMFieldManager fm = new IMFieldManager( "Dcfields", "Dctypes", SQLtables );

		String parControl = request.getParameter( "cControl" );
		String parDevice = request.getParameter( "cDevice" );

		if ( parDevice == null ) {
			parDevice = "HTTPIFACE";
		}

		int control = OrderImport.NEW_ORDER;
		if ( "update".equals( parControl ) ) {
			control = OrderImport.UPDATE_ORDER;
		}
		else if ( "cancel".equals( parControl ) ) {
			control = OrderImport.CANCEL_ORDER;
		}
		else if ( "complete".equals( parControl ) ) {
			control = OrderImport.CREATE_FOR_STUDY;
		}

		Properties params = IfaceToolbox.processParameters( request, fm, fields );

		// Check required fields
		OrderImport.checkData( params, control );

		if ( !OrderImport.importOrder( control, params, is.regID, parDevice ) ) {
			throw new IMException( "An error occured while saving data (error executing command)." );
		}
	}
	catch ( IMException imEx ) {
		errorMsg = imEx.getMessage();
		if ( errorMsg == null ) {
			errorMsg = "An error occured while saving data";
		}
	}
	catch ( Throwable th ) {
		errorMsg = "An error occured while saving data:" + th.toString();
	}

	if ( parBack != null ) {
		// Redirect

		// Replace $$USERID$$ with is.regID in parBack
		// to pass it back to Valyon Joe's program (mammo project)

		String nextParamChar = "&";
		if ( parBack.indexOf( "?" ) == -1 ) {
			nextParamChar = "?";
		}

		parBack = Helper.replace( parBack, "$$USERID$$", is.regID );

		parBack = parBack + nextParamChar + "cResult=" + ( errorMsg == null ? "OK" : "FAILED" );
		parBack = parBack + "&cUserid=" + Helper.URLEncodeUTF8( ( is.regID == null ? "null" : is.regID ) );
		if ( errorMsg != null ) {
			parBack = parBack + "&cError=" + Helper.URLEncodeUTF8( errorMsg );
		}
		response.sendRedirect( parBack );
		return;
	}
	else {
		response.setContentType( "text/plain" );
%>#USERID: <%=is.regID%>
<%
		if ( errorMsg != null ) {

%>#RESULT: FAILED
#ERROR: <%=errorMsg%>
<%
		}
		else {

%>#RESULT: OK
<%
		}
	}

	if ( true ) {
		return;
	}
%>