<%--
 * Component: iface
 *
 * Description:
 *    HTTP API command to merge studies
 * 
 * This is the official HTTP API command redirecting to the WEB GUI
 *
 * @params:
 *
 *   -!- ACCN   accession number of the studies to merge.
 *   -!-       If there are more than one studies matching to an accession number, an error response will be returned.
 *   SYUI   study instance UID of the studies to merge
 *
 *   [cPrimary]      Primary study
 *   [cKeepReports]  Keep all report objects
 *
 *   cBack          URL to go back to after the split operation completes or cancelled
 *                  Special values:
 *                  USE_REFERER : Use the value of the REFERER HTTP header
 *                  USE_DEFAULT : Use default back URL (work list if tabs are displayed, and no back URL if tabs are hidden)
 *   cShowHeaders   use false to hide headers and tabs (default is true)
 *
 *   cUser    user id
 *   cPasswd  password
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.tables.*, imagemed.imsession.*, java.util.*,
			imagemed.util.Helper, imagemed.jsputil.*, imagemed.exception.*, imagemed.lists.*"
	
%><%

	IMSession is = new IMSession( request, response, out );
	String parStudies = request.getParameter( "SYUI" );
	String parPrimary = request.getParameter( "cPrimary" );
	boolean keepReports = "true".equals( request.getParameter( "cKeepReports" ) );
	
	boolean showHeaders = !"false".equals( request.getParameter( "cShowHeaders" ) );

	String parBack =  request.getParameter( "cBack" );
	if ( "USE_REFERER".equals( parBack ) ) {
		parBack = request.getHeader( "REFERER" );
	}
	else if ( "USE_DEFAULT".equals( parBack ) ) {
		if ( showHeaders ) {
			parBack = is.httpx_host + GenericUserList.getPrimaryPage( ListDescriptor.LIST_DEFAULT );
		}
		else {
			parBack = null;
		}
	}
	
	String sessionID =  request.getParameter( "sessionid" );

	StringBuffer url = new StringBuffer( 256 );
	url.append( "/cases/merge.jsp?cIface=" );
	url.append( showHeaders ? "tabs" : "true" );

	boolean hasPrimary = false;
	
	if ( parPrimary != null ) {
		url.append( "&cPrimary=" );
		url.append( Helper.URLEncodeUTF8( parPrimary ) );

		url.append( "&cGr=" );
		url.append( Helper.URLEncodeUTF8( parPrimary ) );
		hasPrimary = true;
	}
	
	if ( parStudies != null ) {
		StringTokenizer st = new StringTokenizer( parStudies, ";" );
		while ( st.hasMoreTokens() ) {
			String study = st.nextToken();
			// Add study to the cGr parameters if it was not yet added along with cParameter 
			if ( !study.equals( parPrimary ) ) {
				url.append( "&cGr=" );
				url.append( Helper.URLEncodeUTF8( study ) );
				
				if ( !hasPrimary ) {
					// no primary study was set yet, this one will be the primary
					url.append( "&cPrimary=" );
					url.append( Helper.URLEncodeUTF8( study ) );
					hasPrimary = true;
				}
			}
		}
	}
	
	if ( keepReports ) {
		url.append( "&cKeepReports=true" );
	}
	if ( parBack != null ) {
		url.append( "&cBack=" );
		url.append( Helper.URLEncodeUTF8( parBack ) );
	}
	if( sessionID != null ) {
		url.append( "&sessionid=" ).append( Helper.URLEncodeUTF8( sessionID ) );
	}
	
	IfaceToolbox.loginAndRedirect( is, url.toString() );
	
	if ( true ) {
		// To avoid sending any other character on the connection after redirect
		return;
	}
%>