<%--
 * Component: iface
 *
 * Description:
 * 	Merges two or more studies into one new study
 *
 * Parameters:
 *
 * @param cGr           List of Study Instance UIDs to be merged
 * @param cOp           "Merge" operation
 * @param cPrimary      Study Instance UID of the Primary Study
 * @param cKeepReports  Keep all reports or Primary Study's report only 
 *
 * The patient and study information in the Primary Study gets copied into the other studies.
 *
 * If cKeepReports is "true" then reports from other studies are attached as addenda to the
 * Primary Study's report.
 *
 * If cKeepReports is not "true" then reports from other studies are purged
 * 
--%><%@
	page import="java.util.*,
			imagemed.exception.*, imagemed.imsession.*, imagemed.jsputil.*,
			imagemed.jsputil.IfaceToolbox.ErrorType"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out );

	is.response.setHeader( "pragma", "no-cache" );
	is.response.setHeader( "Cache-Control", "no-cache, must-revalidate" );
	is.response.setHeader( "Expiry-Date", "Friday, 31-Dec-70 23:59:59 GMT" );
	is.response.setContentType( "text/plain" );

	try {

		if ( !IfaceToolbox.isRegOK( is ) ) {
			throw new IMIfaceException( is, "Has no registration info for this IP." );
		}

		if ( !"Merge".equals( is.request.getParameter( "cOp" ) ) ) {
			throw new IMIfaceException( is, "There is not 'Merge' operation parameter for merging." );
		}

		Vector<String> studies = new Vector<String>();
		String parGr[] = is.request.getParameterValues( "cGr" );
		if ( parGr == null ) {
			throw new IMIfaceException( is, "No studies selected to merge!" );
		}

		for ( int i = 0; i < parGr.length; i++ ) {
			for ( StringTokenizer st = new StringTokenizer( parGr[ i ] ); st.hasMoreTokens(); ) {
				String study = st.nextToken();
				studies.add( study );
			}
		}

		MergeStudies merge = new MergeStudies( studies, is );

		if ( !merge.checkMerge( new Vector<String>(), new Vector<String>() ) ) {
			throw new IMIfaceException( is, merge.getErrorMessage() );
		}

		if ( merge.doMerge() ) {
			IfaceToolbox.printOK( is );
			return;
		}
		else {
			throw new IMIfaceException( is, merge.getErrorMessage() );
		}

	}
	catch ( IMIfaceException imi ) {
		IfaceToolbox.printError( is, imi.getErrorType(), imi.getMessage() );
		return;
	}
%>