<%--
 * Component: iface
 *
 * Description:
 *   interface to initiate user related operations
 *
 * Parameters:
 *
 *		common Parameters:
 *				cOper           : operation ( "new", "update", "delete" or "getid" )
 * 
 *		params for "update" or "delete":
 *				cLocid          : ONLY at "update" or "delete": row ID (LOID) of the location to be edited/deleted
 *
 *		params for "getid":
 *				cRegLocID					: the Registered Location ID of the Location to identify
 *				cName						: the Name of the Location to identify
 *
 *		params for "new" or "update":
 *				qe_XXXX					:	Value for field XXXX
 *
--%><%@
	page import="java.io.*, java.sql.*, java.util.*,
			imagemed.exception.*, imagemed.imsession.*, imagemed.imtables.*, imagemed.jsputil.*,
			imagemed.jsputil.IfaceToolbox.ErrorType, imagemed.tables.*, imagemed.types.IMType,
			imagemed.types.IMType.FldValue, imagemed.types.flag.IMTypeur, imagemed.util.Helper"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out );

	is.response.setContentType( "text/plain" );

	if ( !IfaceToolbox.isRegOK( is ) ) {
		IfaceToolbox.printError( is, ErrorType.Permanent, "Has no registration info for this IP." );
		return;
	}

	if ( !is.hasRight( IMTypeur.USER_MANAGE_RIGHT ) ) {
		IfaceToolbox.printError( is, ErrorType.Permanent, "Has no right to perform this operation. (no User Manage right!)" );
		return;
	}

	String operStr = request.getParameter( "cOper" );
	if ( operStr == null || operStr.length() == 0 ) {
		IfaceToolbox.printError( is, ErrorType.Permanent, "Required parameter \"cOper\" is missing!" );
		return;
	}

	String locID = null;
	if ( "update".equals( operStr ) || "delete".equals( operStr ) ) {
		locID = request.getParameter( "cLocid" );
		if ( locID == null || locID.length() == 0 ) {
			IfaceToolbox.printError( is, ErrorType.Permanent, "Required parameter \"cLocid\" is missing!" );
			return;
		}
	}

	is.sessionVariables.setProperty( "httpIface", "true" );

	try {
		if ( "new".equals( operStr ) ) {
			locID = LocationToolbox.createNewLocation( is );
			if ( locID != null ) {
				IfaceToolbox.printOK( is );
				is.out.println( "#ROWID: " + locID );
			}
			else {
				IfaceToolbox.printError( is, ErrorType.Permanent, "Location ID (row ID) of the newly created record is null!" );
			}
		}
		else if ( "getid".equals( operStr ) ) {
			String reglocID = request.getParameter( "cRegLocID" );
			if ( reglocID == null ) {
				IfaceToolbox.printError( is, ErrorType.Permanent, "Required parameter \"cRegLocID\" is missing!" );
			}
			else {
				String label = request.getParameter( "cName" );
				if ( label == null ) {
					IfaceToolbox.printError( is, ErrorType.Permanent, "Required parameter \"cName\" is missing!" );
				}
				else {
					locID = LocationToolbox.getInnerID( reglocID, label );
					if ( locID != null ) {
						IfaceToolbox.printOK( is );
						is.out.println( "#ROWID: " + locID );
					}
					else {
						IfaceToolbox.printError( is, ErrorType.Permanent, "Location ID (row ID) of the record is null!" );
					}
				}
			}
		}
		else if ( "update".equals( operStr ) ) {
			LocationToolbox.updateLocation( is, locID );
			IfaceToolbox.printOK( is );
		}
		else if ( "delete".equals( operStr ) ) {
			LocationToolbox.deleteLocation( is, locID );
			IfaceToolbox.printOK( is );
		}
	}
	catch ( Throwable th ) {
		IfaceToolbox.printError( is, ErrorType.Permanent, Helper.throwable2String( th ) );
	}

	if ( true ) {
		return;
	}
%>
