<%--
 * Component: iface
 *
 * Description:
 * 	Splits study into two or more studies
 *
 * Parameters:
 *	see: cases/split.jsp
 *
 * Operations:
 *	Split (only)
 *
 * This is an undocumented command intended to be used from the test scripts only
 *
--%><%@
	page import="java.util.*,
			imagemed.exception.*, imagemed.imsession.*, imagemed.jsputil.*,
			imagemed.jsputil.IfaceToolbox.ErrorType, imagemed.types.flag.IMTypeur, 
			imagemed.types.string.IMTypePN, imagemed.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	Splitter splitter = new Splitter( request, "cases/index.jsp" );

	IMSession is = new IMSession( request, response, out );

	is.response.setHeader( "pragma","no-cache" );
	is.response.setHeader( "Cache-Control" , "no-cache, must-revalidate" );
	is.response.setHeader( "Expiry-Date" , "Friday, 31-Dec-70 23:59:59 GMT" );
	is.response.setContentType( "text/plain" );

	try {
		if ( !IfaceToolbox.isRegOK( is ) ) {
			throw new IMIfaceException( is, "Has no registration info for this IP." );
		}
	
		boolean hasEditRight = is.hasRight( IMTypeur.EDIT_RIGHT );
	
		if ( !hasEditRight ) {
			throw new IMIfaceException( is, "You have no right to split studies" );
		}
	
		if ( splitter.getStudy() == null || !"Split".equals( is.request.getParameter( "cOp" ) ) ) {
			throw new IMIfaceException( is, "Missing parameter" );
		}
	
		// Process Request Parameters
		final boolean FORCE = true;
		splitter.save( FORCE );
		splitter.load();
		splitter.checkSplit();
	
		Properties prp = splitter.isStudyLocked( is );
		if ( prp != null ) {
			String lockerName = prp.getProperty( "IMLockOwner" );
			String lockAge = prp.getProperty( "IMLockAge" );
			lockerName = ( null == lockerName ) ? "unknown user" : IMTypePN.displayOrdinaryText( lockerName );
			lockAge = ReportToolbox.getLockAgeMessage( lockAge );
			if ( lockAge.length() > 4 ) {
				lockAge = " " + lockAge.substring( 4 ).trim() + "";
			}
			
			String msg = "study is locked by " + lockerName + lockAge;
			throw new IMIfaceException( is, msg );
		}
	
		// Start splitting if necessary
		if ( splitter.doSplit( is ) ) {
			IfaceToolbox.printOK( is );
			return;
		}
		else {
		  throw new IMIfaceException( is, splitter.getErrorMsg() );
		}
		  
	}
	catch ( IMIfaceException imi ) {
		IfaceToolbox.printError( is, imi.getErrorType(), imi.getMessage() );
		if ( true ) {
			return;
		}
	}
%>