<%--
 ** Component: iface
 **
 ** Description:
 **   WorkList page Lister
 **
 ** Parameters:
 **
 **  @param cList           [userID:]listName
 **  @param sessionid		session number of already logged in user
 **  see:cases/htdocs/index.jsp
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
--%><%@
	page import="imagemed.dotcom.DotcomConfig, java.util.*, imagemed.imsession.*, imagemed.jsputil.*,
			imagemed.util.*, imagemed.tables.*, imagemed.imtables.*,imagemed.imtables.queryqualifier.QueryQualifier,
			imagemed.types.flag.IMTypeur"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%-- Input Parameters --%><%

	IMSession is = new IMSession( request, response, out ); 

	String parUser = request.getParameter( "cUser" );

	is.response.setHeader( "pragma", "no-cache" );
	is.response.setHeader( "Cache-Control" , "no-cache, must-revalidate" );
	is.response.setHeader( "Expiry-Date" , "Friday, 31-Dec-70 23:59:59 GMT" );
	is.response.setContentType( "text/plain" );

	if ( !IfaceToolbox.isRegOK( is ) ) {
		is.out.println( "#USERID: "+is.regID );
		is.out.println( "#RESULT: FAILED" );
		is.out.println( "#ERROR: Has no registration info for this IP." );
		return;
	}

	//if session number is set, it means that it was loaded by 'is' and the page can be reloaded with the choosen session 
	String sessionID = is.request.getParameter( "sessionid" );
	if ( sessionID != null) {
		is.response.sendRedirect( is.httpx_host + "/iface/worklist.jsp?" + Helper.passParamsExcept(request, "sessionid"));
	}
	
	Defs casesDefs = new Defs( is, parUser );

	is.sessionVariables.setProperty("httpIface", "true");

	String thisPageFN = "/cases/index.jsp";          // Full Name
	String SQLtables[] = DotcomConfig.selfDevice().isNoObjectTable()
		? new String [] { "Dcstudy", "CacheState" }
		: new String [] { "Dcstudy", "Dcobject", "CacheState" };

	// pageSize and refresh comes from defs.jspi
	String defaultFields[] = { "DATE" , "PANM", "STAT" , "MODY", "DSCR", "PHRF", "PHRD", "NIMG" };
	String defaultSort[] = { "a_DATE" };

	boolean isAdmin = ( is.regRights != null && is.regRights.indexOf('A') != -1 );

	WorklistTableParams tparams = null;
	try {
		tparams = new WorklistTableParams( is, casesDefs.getFilterUser(), isAdmin, false );
	}
	catch ( Exception e ) {
	}

	tparams.setDefaultFields( defaultFields );
	tparams.setDefaultSort( defaultSort );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( Defs.pageSize );
	tparams.setDefaultRefreshTime( Defs.refresh );
	tparams.setDefaultChangedFirst( "false" );
	tparams.setDefaultPriorityFirst( "false" );

	String passPars = tparams.getPassParams();

	String qs = is.request.getQueryString();
	qs = ( qs == null ) ? "" : "?" + qs;
	String tU = is.httpx_host + is.request.getRequestURI() + qs;
	String encodedThisURL = Helper.URLEncodeUTF8( tU );%><%--  Prepare tables --%><%TableDescriptor tdesc = new TableDescriptor( thisPageFN, true, true, true, true );

	String backParams = "&cBack=" + encodedThisURL;
	String relevParams = "&cTableParams=" + Helper.URLEncodeUTF8( passPars ) + tparams.getPassFields();

	boolean doSlow = "true".equals( is.request.getParameter( "cDoSlowQuery" ) );

	Properties extraProperties = new Properties();
	extraProperties.setProperty( "Rights",( is.regRights == null ? "" : is.regRights ) );
	extraProperties.setProperty( "RelevParams", relevParams );
	extraProperties.setProperty( "BackParams", backParams );

	WorklistProperties tprop = new WorklistProperties( extraProperties );
	FieldManager fm = new IMSQLFieldManager( "Dcfields", "Dctypes", SQLtables );

	tdesc.setTableParams( tparams );
	tdesc.setTablePackage( "imagemed.imtables" );
	tdesc.setTableProperties( tprop );
	tdesc.setFieldManager( fm );
	tdesc.setSortDepth( 3 );

	//Unnecessary - only workaround an exception at tableInit()
	tdesc.addExtraColumn( "_FIRST", new Column( new DataHeader( "SYUI" ), new DataCell( "SYUI" ), "SYUI" ) );

	if( !doSlow || !is.hasRight( IMTypeur.RESTRICTED_QUERY_RIGHT ) ) {
		QueryQualifier qq = new QueryQualifier();
		String queryResult = qq.qualifyFilters( tparams, true, false );
		if( ( QueryQualifier.MEDIUM.equals( queryResult ) && !doSlow ) ||
				QueryQualifier.BAD.equals( queryResult ) ) { // ha joga is van meg parametert is ad, ide mar nem is jovunk!
			String help = qq.getHelp();
			is.out.println( "#USERID: " + is.regID );
			is.out.println( "#RESULT: FAILED" );
			is.out.println( "#ERROR: This query is too slow." + ( help == null ? "" : " Hint:" + help ) );
			return;
		}
	}

	WorklistResult result = new WorklistResult( is, tdesc );

	tdesc.setResult( result );

	Table table = new Table( tdesc );

	if( !table.printTabSepTableContent( is.out ) ) {
		// if generating didn't succeed, because query was too slow, problem has already been written
		return;
	}
	is.out.println( "#USERID: " + is.regID );

	// detect if there are some invalid fields (or object-level fields at object-less CWL)
	boolean partial = false;
	String[] vfArray = is.imRequest.getVals( "cFields" );
	if ( vfArray != null ) {
		for ( int i = 0; i < vfArray.length; i++ ) {
			String colid = vfArray[ i ];
			if ( colid != null ) {
				if ( fm.getHeaderName( colid ) == null ) {
					if ( !partial ) {
						partial = true;
						is.out.println( "#RESULT: PARTIAL" );
						is.out.print( "#INVALIDFIELDS:" );
					}
					is.out.print( colid + "\t" );
				}
			}
		}
	}

	if ( partial ) {
		is.out.println();
	}
	else {
		is.out.println( "#RESULT: OK" );
	}
	
	if ( true ) {
		return;
	}
	
%><%--result.getDebug()--%>